;;; -*- syntax: common-lisp; package: cmn; base: 10; mode: lisp -*-

;;; most (>70%) of CMN's time is spent in the lisp format function, so by dropping
;;; into C instead we can speed CMN up by about a factor of 4.

(in-package :cmn)

#+(and excl next)
  (progn
    (ff:defforeign 'c-open :entry-point "_OpenCMNFile" :arg-checking nil :arguments '(string) :return-type :integer)
    (ff:defforeign 'c-close :entry-point "_CloseCMNFile" :arg-checking nil :arguments nil)
    (ff:defforeign 'c-print :entry-point "_PrintCMNFile" :arg-checking nil :arguments '(string))
    (ff:defforeign 'c-comment :entry-point "_CommentCMNFile" :arg-checking nil :arguments '(string))
    (ff:defforeign 'c-lineto :entry-point "_LinetoCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-rlineto :entry-point "_RLinetoCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-moveto :entry-point "_MovetoCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-rmoveto :entry-point "_RMovetoCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-curveto :entry-point "_CurvetoCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-linewidth :entry-point "_LinewidthCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-linewidthcleared :entry-point "_LinewidthClearedCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-matrix :entry-point "_MatrixCMNFile" :arg-checking nil :arguments '(array))
    (ff:defforeign 'c-fill-in :entry-point "_FillinCMNFile" :arg-checking nil :arguments '(array string))
    (ff:defforeign 'c-text :entry-point "_FontTextCMNFile" :arg-checking nil :arguments '(string fixnum string))
    )

#+(and excl (not acl-50) (not acl-61) (or linux sgi sun))
  (progn
    (ff:defforeign 'c-open :entry-point "OpenCMNFile" :arg-checking nil :arguments '(string) :return-type :integer)
    (ff:defforeign 'c-close :entry-point "CloseCMNFile" :arg-checking nil :arguments nil)
    (ff:defforeign 'c-print :entry-point "PrintCMNFile" :arg-checking nil :arguments '(string))
    (ff:defforeign 'c-comment :entry-point "CommentCMNFile" :arg-checking nil :arguments '(string))
    (ff:defforeign 'c-lineto :entry-point "LinetoCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-rlineto :entry-point "RLinetoCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-moveto :entry-point "MovetoCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-rmoveto :entry-point "RMovetoCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-curveto :entry-point "CurvetoCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-linewidth :entry-point "LinewidthCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-linewidthcleared :entry-point "LinewidthClearedCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-matrix :entry-point "MatrixCMNFile" :arg-checking nil :arguments '((simple-array single-float (*))) :call-direct t :prototype t)
    (ff:defforeign 'c-fill-in :entry-point "FillinCMNFile" :arg-checking nil :arguments '((simple-array single-float (*)) string) :prototype t)
    (ff:defforeign 'c-text :entry-point "FontTextCMNFile" :arg-checking nil :arguments '(string integer string))
   )

#+(and excl acl-50 (not acl-60) (not acl-61) (or linux sgi sun))
  (progn
    (ff:def-foreign-call (c-open "OpenCMNFile") ((arr (* :char) string)) :returning :int)
    (ff:def-foreign-call (c-close "CloseCMNFile") (:void) :returning :void)
    (ff:def-foreign-call (c-print "PrintCMNFile") ((arr (* :char) string)) :returning :void)
    (ff:def-foreign-call (c-comment "CommentCMNFile") ((arr (* :char) string)) :returning :void)
    (ff:def-foreign-call (c-lineto "LinetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-rlineto "RLinetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-moveto "MovetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-rmoveto "RMovetoCMNFile") ((arr (* :float) (simple-array single-float (*))))  :returning :void)
    (ff:def-foreign-call (c-curveto "CurvetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-linewidth "LinewidthCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-linewidthcleared "LinewidthClearedCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-matrix "MatrixCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-fill-in "FillinCMNFile") ((arr (* :float) (simple-array single-float (*))) (arr1 (* :char) string)) :returning :void)
    (ff:def-foreign-call (c-text "FontTextCMNFile") ((arr0 (* :char) string) (i :int) (arr1 (* :char) string)) :returning :void)
   )

#+(and excl acl-60 (not acl-61) (or linux sgi sun))
  (progn
    (ff:def-foreign-call (c-open "OpenCMNFile") ((arr (* :char))) :returning :int)
    (ff:def-foreign-call (c-close "CloseCMNFile") (:void) :returning :void)
    (ff:def-foreign-call (c-print "PrintCMNFile") ((arr (* :char))) :returning :void)
    (ff:def-foreign-call (c-comment "CommentCMNFile") ((arr (* :char))) :returning :void)
    (ff:def-foreign-call (c-lineto "LinetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-rlineto "RLinetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-moveto "MovetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-rmoveto "RMovetoCMNFile") ((arr (* :float) (simple-array single-float (*))))  :returning :void)
    (ff:def-foreign-call (c-curveto "CurvetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-linewidth "LinewidthCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-linewidthcleared "LinewidthClearedCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-matrix "MatrixCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-fill-in "FillinCMNFile") ((arr (* :float) (simple-array single-float (*))) (arr1 (* :char))) :returning :void)
    (ff:def-foreign-call (c-text "FontTextCMNFile") ((arr0 (* :char)) (i :int) (arr1 (* :char))) :returning :void)
   )

#+(and excl acl-61 (or linux sgi sun))
  (progn
    (ff:def-foreign-call (c-open "OpenCMNFile")
			 ((arr (* :char)))
			 :strings-convert t
			 :returning :int)
    (ff:def-foreign-call (c-close "CloseCMNFile") (:void) :returning :void)
    (ff:def-foreign-call (c-print "PrintCMNFile")
			 ((arr (* :char)))
			 :strings-convert t
			 :returning :void)
    (ff:def-foreign-call (c-comment "CommentCMNFile")
			 ((arr (* :char)))
			 :strings-convert t
			 :returning :void)
    (ff:def-foreign-call (c-lineto "LinetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-rlineto "RLinetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-moveto "MovetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-rmoveto "RMovetoCMNFile") ((arr (* :float) (simple-array single-float (*))))  :returning :void)
    (ff:def-foreign-call (c-curveto "CurvetoCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-linewidth "LinewidthCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-linewidthcleared "LinewidthClearedCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-matrix "MatrixCMNFile") ((arr (* :float) (simple-array single-float (*)))) :returning :void)
    (ff:def-foreign-call (c-fill-in "FillinCMNFile")
			 ((arr (* :float) (simple-array single-float (*))) (arr1 (* :char)))
			 :strings-convert t
			 :returning :void)
    (ff:def-foreign-call (c-text "FontTextCMNFile")
			 ((arr0 (* :char)) (i :int) (arr1 (* :char)))
			 :strings-convert t
			 :returning :void)
   )

#+(and lispworks linux)
  (progn
    (fli:define-foreign-function (c-open-1 "OpenCMNFile" :source) ((name :pointer)) :result-type :int :language :ansi-c)
    (defun c-open (file-name)
      (fli:with-foreign-string (pointer element-count byte-count) file-name
        (declare (ignore element-count byte-count))
        (c-open-1 pointer)))
    
    (fli:define-foreign-function (c-close "CloseCMNFile" :source) () :result-type :void :language :ansi-c)

    (fli:define-foreign-function (c-print-1 "PrintCMNFile" :source) ((arr :pointer)) :result-type :void :language :ansi-c)
    (defun c-print (str)
      (fli:with-foreign-string (pointer element-count byte-count) str
        (declare (ignore element-count byte-count))
        (c-print-1 pointer)))
      
    (fli:define-foreign-function (c-comment-1 "CommentCMNFile" :source) ((arr :pointer)) :result-type :void :language :ansi-c)
    (defun c-comment (str)
      (fli:with-foreign-string (pointer element-count byte-count) str
        (declare (ignore element-count byte-count))
        (c-comment-1 pointer)))
      
    (fli:define-foreign-function (c-text-1 "FontTextCMNFile" :source) ((arr0 :pointer) (i :int) (arr1 :pointer)) :result-type :void :language :ansi-c)
    (defun c-text (str i str1)
      (fli:with-foreign-string (pointer element-count byte-count) str
        (declare (ignore element-count byte-count))
       (fli:with-foreign-string (pointer1 element-count1 byte-count1) str1
         (declare (ignore element-count1 byte-count1))
	 (c-text-1 pointer i pointer1))))
    
    (fli:define-foreign-function (c-lineto "LinetoCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-rlineto "RLinetoCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-moveto "MovetoCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-rmoveto "RMovetoCMNFile" :source) ((arr :lisp-array))  :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-curveto "CurvetoCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-linewidth "LinewidthCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-linewidthcleared "LinewidthClearedCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    (fli:define-foreign-function (c-matrix "MatrixCMNFile" :source) ((arr :lisp-array)) :result-type :void :language :ansi-c)
    
    (fli:define-foreign-function (c-fill-in-1 "FillinCMNFile" :source) ((arr :lisp-array) (arr1 :pointer)) :result-type :void :language :ansi-c)
    (defun c-fill-in (arr str)
      (fli:with-foreign-string (pointer element-count byte-count) str
        (declare (ignore element-count byte-count))
	(c-fill-in-1 arr pointer)))

  )
