;;; -*- syntax: common-lisp; package: cmn; base: 10; mode: lisp -*-
;;;
;;; Traditional western music notation (CMN=Common Music Notation)


#+excl (when (eq excl:*current-case-mode* :case-sensitive-upper)
	 (warn "you've chosen the one case (sensitive-upper) that is incompatible with cmn -- changing to insensitive-upper")
	 (excl:set-case-mode :case-insensitive-upper))

#+gcl (in-package :cmn :use '(:lisp :pcl :loop))
#+gcl (shadow 'system)
#+gcl (shadow 'make-system)
#+gcl (shadow 'double)

#+(and excl (not cltl2)) (require :loop)
#+(and excl (not cltl2)) (in-package :cmn :use '(:lisp :pcl :loop))

#+(and excl cltl2) (defpackage :cmn (:use :common-lisp :clos) (:shadow rest) (:import-from :excl ratiop exit))
#+(and excl cltl2) (in-package :cmn)

#+lispworks (defpackage :cmn (:use :common-lisp :clos) (:shadow rest) (:import-from :cl-user quit))
#+lispworks (in-package :cmn)
	      
#+clisp 
  (progn
    (defpackage :cmn 
      #-ansi-cl (:use :loop :lisp :clos)
      #+ansi-cl (:use :loop :lisp :clos)
      #-ansi-cl (:import-from :lisp bye shell)
      #+ansi-cl (:import-from :ext bye shell)
      #+(and ansi-cl syscalls) (:shadow posix:y0 posix:y1)
      (:shadow "REST")
      (:shadow "FINALIZE"))
    (in-package :cmn)
    )

#+clisp (if (and (find-package "EXT")
		 (find-symbol "WITHOUT-PACKAGE-LOCK" (find-package "EXT")))
	    (pushnew :have-without-package-lock *features*))
#+clisp (if (and (find-package "EXT")
		 (find-symbol "QUIT" (find-package "EXT")))
	    (pushnew :have-quit *features*))

#+cmu
  (progn
    (defpackage :cmn
      (:use :loop :pcl :lisp)
      (:shadow common-lisp:rest)
      (:import-from :extensions quit)
      (:shadowing-import-from "PCL" "BUILT-IN-CLASS" "CLASS-NAME" "CLASS-OF" "FIND-CLASS" "STANDARD-CLASS"))
    (in-package :cmn))

#+sbcl
  (progn
    (defpackage :cmn
      (:use :common-lisp)
      (:import-from :sb-ext quit)      
      (:shadow common-lisp:rest common-lisp:eighth))
    (in-package :cmn))

#+(and mcl (not openmcl))
  (progn
    (defpackage :cmn 
      (:use :common-lisp)
      (:shadow common-lisp:rest CCL:COPY CCL:CANCEL))
    (in-package :cmn)
    )

#+openmcl
  (progn
    (defpackage :cmn 
      (:use :common-lisp) 
      (:import-from :ccl quit)
      (:shadow common-lisp:rest))
    (in-package :cmn)
    )

#-(or clisp cltl2) (shadow 'rest)

(pushnew :cmn *features*)

(defvar *cmn-binary-directory* "./")
(defvar *cmn-source-directory* "./")

(defvar *cmn-version* "Common Music Notation 17-Dec-04")
(defvar *cmn-news* 
  "
17-Dec: woodblock glyph (Anders Vinjar)
5-Aug:  sbcl 0.8.13 and cmucl 19a changes.
13-May: ACL 7 changes.
22-Mar: port to SBCL on the Sun and in OSX 10.3.
8-Mar:  MCL #_DrawChar bugfix thanks to Pierre Klanac.
4-Feb:  hack around incredible SBCL loop pedantry.
29-Jan: double-treble, quad-treble, and quad-bass clefs.
26-Jan: MCL 5.0 support thanks to Joakim S and George K.
")

;;; change log moved to HISTORY.cmn

